<?php
include_once(dirname(__FILE__)."/class.squid.acls.inc");
include_once(dirname(__FILE__)."/class.mysql.squid.builder.php");
include_once(dirname(__FILE__)."/class.tcpip.inc");
class acls_cache_deny{
	public $acl=array();
	
	private $cachefile="/etc/squid3/GlobalAccessManager_deny_cache.conf";
	
	function __construct(){
		
		
		
	}
	
	private function root_squid_version_nocache(){
		if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
		if(!class_exists("unix")){include_once("/usr/share/artica-postfix/framework/class.unix.inc");}
		$unix=new unix();
	
		$squidbin=$unix->LOCATE_SQUID_BIN();
		if($squidbin==null){$squidbin=trim($unix->find_program("squid3"));}
		if(!is_file($squidbin)){return;}
		exec("$squidbin -v 2>&1",$results);
	
		$this->SQUID_VERSIONS_LOGS[]="# Binary $squidbin";
	
	
		while (list ($num, $val) = each ($results)){
				if(!preg_match("#Squid Cache: Version.*?([0-9\.]+)#", $val,$re)){continue;}
				if($re[1]=="2.7."){$re[1]="2.7.0";}
				if($re[1]=="3.0."){$re[1]="3.0.0";}
				if($re[1]=="3.1."){$re[1]="3.1.0";}
				if($re[1]=="3.2."){$re[1]="3.2.0";}
				if($re[1]=="3.3."){$re[1]="3.3.0";}
				if($re[1]=="3.4."){$re[1]="3.4.0";}
				if($re[1]=="3.5."){$re[1]="3.5.0";}
				if($re[1]=="3.6."){$re[1]="3.6.0";}
				if($re[1]=="3.7."){$re[1]="3.7.0";}
				$GLOBALS[__FUNCTION__]=$re[1];
				return $re[1];
			
		}
	
	}
	
	function url_regex_nocache(){
		$f[]="\.google.[a-z]\/url\?";
		$f[]="\.crl$";
		@file_put_contents("/etc/squid3/url_regex_nocache.conf", @implode("\n", $f));
		
	}
	
	function build(){
		if(!is_file("/etc/artica-postfix/settings/Daemons/SquidCacheLevel")){@file_put_contents("/etc/artica-postfix/settings/Daemons/SquidCacheLevel", 4);}
		$root_squid_version_nocache=$this->root_squid_version_nocache();
		$sock=new sockets();
		$this->acl[]="#Builded on ". date("Y-m-d H:i:s"). " Squid v{$root_squid_version_nocache}";
		
		$VERZ=explode(".",$root_squid_version_nocache);
		$MAJOR=intval($VERZ[0]);
		$MINOR=intval($VERZ[1]);
		
		$SquidCacheLevel=intval(@file_get_contents("/etc/artica-postfix/settings/Daemons/SquidCacheLevel"));
		$SquidUrgency=intval(@file_get_contents("/etc/artica-postfix/settings/Daemons/SquidUrgency"));
		
		if($SquidCacheLevel==0){
			$this->acl[]="# Do not cache ALL domains: SquidCacheLevel:$SquidCacheLevel\n";
			$this->acl[]="acl DoNotCache dstdomain all";
			
			return;
		}
		
		
		if($SquidUrgency==1){
			$this->acl[]="# Emergency enabled, deny ACL `DoNotCache`";
			$this->acl[]="acl DoNotCache dstdomain all";
			return;
		}
		
		$this->acl[]="acl NoCacheURLs url_regex -i \"/etc/squid3/url_regex_nocache.conf\""; 
		$this->acl[]="acl DoNotCache dstdomain .artica.fr";
		$this->acl[]="acl DoNotCache dstdomain .articatech.net";
		$this->acl[]="acl DoNotCache dstdomain .clamav.net";
		$this->acl[]="acl DoNotCache dstdomain .sanesecurity.net";
		$this->acl[]="acl DoNotCache dstdomain .rfxn.com";
		$this->acl[]="acl DoNotCachedst dst 192.168.0.0/16";
		$this->acl[]="acl DoNotCachedst dst 37.187.156.120";
		
		$this->webfilters_blkwhlts();
		$this->deny_cache_domains();
		
		if($MAJOR>2){
			if($MINOR>4){
				$this->acl[]="cache deny DoNotCachedst";
				$this->acl[]="cache deny DoNotCache";
				$this->acl[]="cache deny DoNotCachedst";
				$this->acl[]="cache deny MgRPort";
				$this->acl[]="cache deny NoCacheURLs";
				
				$this->acl[]="send_hit deny NoCacheURLs";
				$this->acl[]="send_hit deny DoNotCache";
				$this->acl[]="send_hit deny DoNotCachedst";
				$this->acl[]="send_hit deny MgRPort";
				$this->acl[]="store_miss deny NoCacheURLs";
				$this->acl[]="store_miss deny DoNotCache";
				$this->acl[]="store_miss deny DoNotCachedst";
				
				
				
			}
		}
	}
	
	private function deny_cache_domains(){
		$already=array();
		$q=new mysql_squid_builder();
		$q->QUERY_SQL("CREATE TABLE IF NOT EXISTS `deny_cache_domains` ( `items` VARCHAR(256) NOT NULL PRIMARY KEY ) ENGINE=MYISAM;");
		$sql="SELECT items FROM deny_cache_domains";
		$results=$q->QUERY_SQL($sql);
		$IPClass=new IP();
		
		
		$DOMAINS=array();
		$already["teamviewer.com"]=true;
		$DOMAINS[]="teamviewer.com";
		
		
		while($ligne=@mysqli_fetch_array($results,MYSQLI_ASSOC)){
			$www=trim($ligne["items"]);
			$www_def=$www;
			if($www==null){continue;}
			
			if($IPClass->isIPAddressOrRange($www)){
				$this->acl[]="acl DoNotCachedst dst $www";
				continue;
			}
			

			$www=$this->BaseNameWebSite($www);
			if($www==null){continue;}
			if(isset($already[$www])){continue;}
			$already[$www]=true;
			
			$DOMAINS[]=$www;
			
			
		}
		if(count($DOMAINS)>0){
			$acls=new squid_acls();
			$FINAL=$acls->clean_dstdomains($DOMAINS);
			while (list ($index, $domain) = each ($FINAL) ){
				$this->acl[]="acl DoNotCache dstdomain $domain";
			}
		}
			
		
	}
	private function BaseNameWebSite($www){
		if(trim($www)==null){return;}
		if(is_numeric(trim($www))){return;}
			
		if(strpos(" $www", "//")>0){
			$arrayURI=parse_url($www);
			$www=$arrayURI["host"];
	
		}
		if(preg_match("#^www\.(.+)#", $www,$re)){$www=$re[1];}
		if(preg_match("#(.+):[0-9]+#", $www,$re)){$www=$re[1];}
		if(substr($www,0,1)=="."){$www=substr($www, 1,strlen($www));}
		if(substr($www,0,1)=="^"){$www=substr($www, 1,strlen($www));}
		if(substr($www,strlen($www)-1,1)=="/"){$www=substr($www, 0,strlen($www)-1);}
		$sitebase=$www;
		$sitebase=str_replace('.*.', '.', $sitebase);
		$sitebase=str_replace('*', '.', $sitebase);
		$sitebase=str_replace('$', '', $sitebase);
		$sitebase=str_replace('(', '', $sitebase);
		$sitebase=str_replace(')', '', $sitebase);
		$sitebase=str_replace(';', '.', $sitebase);
		$sitebase=str_replace(',', '.', $sitebase);
		$sitebase=str_replace('%', '', $sitebase);
		$sitebase=str_replace('+', '', $sitebase);
		$sitebase=str_replace('/', '', $sitebase);
		$sitebase=str_replace('?', '', $sitebase);
		$sitebase=str_replace('!', '', $sitebase);
		$sitebase=str_replace(':', '', $sitebase);
		$sitebase=str_replace('{', '', $sitebase);
		$sitebase=str_replace('}', '', $sitebase);
		$sitebase=str_replace('^', '', $sitebase);
		$sitebase=str_replace('\\', '', $sitebase);
		$sitebase=str_replace('\'', '', $sitebase);
		$sitebase=str_replace('"', '', $sitebase);
		$sitebase=str_replace('&', '', $sitebase);
		$sitebase=str_replace('<', '', $sitebase);
		$sitebase=str_replace('>', '', $sitebase);
		$sitebase=str_replace('[', '', $sitebase);
		$sitebase=str_replace(']', '', $sitebase);
		return $sitebase;
	}
	
	private function webfilters_blkwhlts(){
		$q=new mysql_squid_builder();
		if(!$q->TABLE_EXISTS("webfilters_blkwhlts")){return;}
		if($q->COUNT_ROWS("webfilters_blkwhlts")==0){return;}
		$already=array();
		$sql="SELECT pattern,PatternType FROM webfilters_blkwhlts WHERE blockType=4 AND enabled=1";
		$results=$q->QUERY_SQL($sql);
			
		$this->acl[]="# Do not cache domains: ". mysqli_num_rows($results)." items in ".__CLASS__."/".__FUNCTION__." Line:".__LINE__;

			
		while($ligne=@mysqli_fetch_array($results,MYSQLI_ASSOC)){
			$www=trim($ligne["pattern"]);
			$www_def=$www;
			if($www==null){continue;}
			if($ligne["PatternType"]==2){
				$sq=new squid_acls();
				$sqgroups=$sq->GetItems($www,"dstdomain");
				while (list ($indexed, $www) = each ($sqgroups) ){$www=$this->BaseNameWebSite($www);if($www==null){continue;}if(isset($already[$www])){continue;}$already[$www]=true;$acl[]="acl DoNotCache dstdomain .$www";continue;}
				continue;
			}
			if($ligne["PatternType"]<>0){continue;}
			$www=$this->BaseNameWebSite($www);
			if($www==null){continue;}
			if(isset($already[$www])){continue;}
			$already[$www]=true;
			
			if(substr($www_def,0,1)=="^"){
				$this->acl[]="acl DoNotCache dstdomain $www";
				continue;
			}
			
			$this->acl[]="acl DoNotCache dstdomain .$www";
		
		}
		
	}
	
	
	
}
