<?php

function __debian_version(){
	if(isset($GLOBALS["DEBIAN_VERSION"])){return $GLOBALS["DEBIAN_VERSION"];}
	if(!is_file("/etc/debian_version")){return;}
	$ver=trim(@file_get_contents("/etc/debian_version"));
	preg_match("#^([0-9]+)\.#",$ver,$re);
	if(preg_match("#squeeze\/sid#",$ver)){return 6;}
	$Major=$re[1];
	if(!is_numeric($Major)){return;}
	$GLOBALS["DEBIAN_VERSION"]=$Major;
	return $Major;

}
function __MSKTUTIL_VERSION(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	$msktutil=$GLOBALS["CLASS_UNIX"]->find_program("msktutil");
	$t=exec("$msktutil --version 2>&1");
	if($GLOBALS["VERBOSE"]){echo "$msktutil -> $t\n";}
	if(preg_match("#msktutil version\s+([0-9\.]+)#", $t,$re)){
		$GLOBALS[__FUNCTION__]=$re[1];
		return $GLOBALS[__FUNCTION__];
	}
}

function __DSC_VERSION(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	$dsc=$GLOBALS["CLASS_UNIX"]->find_program("dsc");
	$t=exec("$dsc -v 2>&1");
	if($GLOBALS["VERBOSE"]){echo "$dsc -> $t\n";}
	if(preg_match("#dsc version\s+([0-9\.]+)#", $t,$re)){
		$GLOBALS[__FUNCTION__]=$re[1];
		return $GLOBALS[__FUNCTION__];
	}
	
}
function __ulogd_version(){
	if(isset($GLOBALS["ULOGDVERSION"])){return $GLOBALS["ULOGDVERSION"];}
	exec("/usr/local/sbin/ulogd -V 2>&1",$results);
	foreach ($results as $line){

		if(preg_match("#ulogd Version\s+([0-9\.]+)#", $line,$re)){
			$GLOBALS["ULOGDVERSION"]= $re[1];
			return $GLOBALS["ULOGDVERSION"];
		}
	}

}

function __ipaudit_version(){
	if(isset($GLOBALS["ipaudit_version"])){return $GLOBALS["ipaudit_version"];}
	$Masterbin="/usr/local/sbin/ipaudit";
	if(!is_file($Masterbin)){return null;}
	@chmod($Masterbin,0755);
	exec("$Masterbin -v 2>&1",$results);
	while (list ($num, $line) = each ($results)){
		$line=trim($line);
		if($line==null){continue;}
		if(!preg_match("#^([0-9\.]+)\s+\(compiled#",$line,$re)){continue;}
		$GLOBALS["ipaudit_version"]=$re[1];
	}

	if(isset($GLOBALS["ipaudit_version"])){return $GLOBALS["ipaudit_version"];}

}

function __tftpd_version(){
	if(isset($GLOBALS["tftpd_version"])){return $GLOBALS["tftpd_version"];}
	$Masterbin="/usr/sbin/in.tftpd";
	if(!is_file($Masterbin)){return null;}
	@chmod($Masterbin,0755);
	exec("$Masterbin -V 2>&1",$results);
	while (list ($num, $line) = each ($results)){
		$line=trim($line);
		if($line==null){continue;}
		if(!preg_match("#^tftp-hpa\s+([0-9\.]+),#",$line,$re)){continue;}
		$GLOBALS["tftpd_version"]=$re[1];
	}
	
	if(isset($GLOBALS["tftpd_version"])){return $GLOBALS["tftpd_version"];}
	
}

 

function __mysqld_version(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	if(!isset($GLOBALS["CLASS_UNIX"])){$GLOBALS["CLASS_UNIX"]=new unix();}
	$mysqld=$GLOBALS["CLASS_UNIX"]->find_program("mysqld");
	exec("$mysqld --version 2>&1",$results);
	while (list ($num, $ligne) = each ($results) ){

		if(preg_match("#mysqld.*?([0-9\.\-]+)#", $ligne,$re)){
			$GLOBALS[__FUNCTION__]=$re[1];
			return $GLOBALS[__FUNCTION__];
		}
	}
}

function __debian_version_name(){
	if(isset($GLOBALS["PRETTY_NAME"])){return $GLOBALS["PRETTY_NAME"];}
	if(!is_file("/etc/os-release")){return;}
	$f=explode("\n",@file_get_contents("/etc/os-release"));
	foreach ($f as $line){
		
		if(preg_match("#PRETTY_NAME=\"(.+?)[0-9]+\s+(.*?)\"#", $line,$re)){
			$debian_version=trim(@file_get_contents("/etc/debian_version"));
			$GLOBALS["PRETTY_NAME"]=$re[1]." $debian_version {$re[2]}";
			return $GLOBALS["PRETTY_NAME"];
		}
	}
	
}
function __ArchStruct(){
	if(isset($GLOBALS["__ArchStruct"])){return $GLOBALS["__ArchStruct"];}
	$uname=$GLOBALS["CLASS_UNIX"]->find_program("uname");
	exec("$uname -m 2>&1",$results);
	foreach ($results as $line){
		if(preg_match("#i[0-9]86#", $line)){
			$GLOBALS["__ArchStruct"]=32;
			return 32;
		}
		if(preg_match("#x86_64#", $line)){
			$GLOBALS["__ArchStruct"]=64;
			return 64;
		}
	}
}

//##############################################################################

function Build_default_values(){
	$XVF_WORKDIR=base64_decode("L3Vzci9sb2NhbC9zaGFyZS9hcnRpY2E=");
	$XVF_WORKFILE=base64_decode('LmxpYw==');
	$XVF_WORKPATH="$XVF_WORKDIR/$XVF_WORKFILE";
	$TVF_WORKPATH=base64_decode("L2V0Yy9hcnRpY2EtcG9zdGZpeC9zZXR0aW5ncy9EYWVtb25zL0NPUlBfTElDRU5TRQ==");
	if($GLOBALS["VERBOSE"]){echo "PROCESS 1 --- START --- \n";}
	if(!isset($GLOBALS["CLASS_UNIX"])){$GLOBALS["CLASS_UNIX"]=new unix();}
	if(is_file("/usr/share/artica-postfix/exec.squid.purge.php")){@unlink("/usr/share/artica-postfix/exec.squid.purge.php");}
	if(is_file("/usr/share/artica-postfix/exec.frox.php")){@unlink("/usr/share/artica-postfix/exec.frox.php");}
	if(!is_file("/etc/artica-postfix/settings/Daemons/EnableInfluxDB")){@file_put_contents("/etc/artica-postfix/settings/Daemons/EnableInfluxDB", 1);}
	$EnableInfluxDB=trim(@file_get_contents("/etc/artica-postfix/settings/Daemons/EnableInfluxDB"));
	if(!is_numeric($EnableInfluxDB)){@file_put_contents("/etc/artica-postfix/settings/Daemons/EnableInfluxDB", 1);}
	
	if(!is_file("/etc/artica-postfix/settings/Daemons/AllowSquidWhitelistsSSL")){@file_put_contents("/etc/artica-postfix/settings/Daemons/AllowSquidWhitelistsSSL", 1);}
	if(!is_file("/etc/artica-postfix/settings/Daemons/SquidGuardClientEnableMemory")){@file_put_contents("/etc/artica-postfix/settings/Daemons/SquidGuardClientEnableMemory", 1);}
	if(!is_file("/etc/artica-postfix/settings/Daemons/SquidGuardClientMaxMemoryItems")){@file_put_contents("/etc/artica-postfix/settings/Daemons/SquidGuardClientMaxMemoryItems", 100000);}
	if(!is_file("/etc/artica-postfix/settings/Daemons/AllowWindowsUpdates")){@file_put_contents("/etc/artica-postfix/settings/Daemons/AllowWindowsUpdates", 1);}
		if(!is_file("/etc/artica-postfix/settings/Daemons/SquidLogsExceptions")){@file_put_contents("/etc/artica-postfix/settings/Daemons/SquidLogsExceptions", "127.0.0.1");}
	if(!is_file("/etc/artica-postfix/settings/Daemons/UseSimplifiedCachePattern")){@file_put_contents("/etc/artica-postfix/settings/Daemons/UseSimplifiedCachePattern", 1);}
	if(!is_file("/etc/artica-postfix/settings/Daemons/SquidCacheLevel")){@file_put_contents("/etc/artica-postfix/settings/Daemons/SquidCacheLevel", 3);}
	
	$SET0[]="NmapScanEnabled";
	$SET0[]="APACHE_MOD_BW";
	$SET0[]="EnableScanComputersNet";
	foreach ($SET0 as $filename){
		if(!is_file("/etc/artica-postfix/settings/Daemons/$filename")){
			@file_put_contents("/etc/artica-postfix/settings/Daemons/$filename", 0);
		}
		
	}
	
	
	
	if(!is_file("/usr/local/sbin/ipaudit")){
	 if(is_file("/usr/share/artica-postfix/bin/install/ipaudit.tar.gz")){
	 	$tar=$GLOBALS["CLASS_UNIX"]->find_program("tar");
	 	shell_exec("$tar xf /usr/share/artica-postfix/bin/install/ipaudit.tar.gz -C /usr/local/sbin/");
	 	if(is_file("/usr/local/sbin/ipaudit")){
	 		squid_admin_mysql(0, "New Feature installed IP traffic summarizer in System/Monitor !", "See https://youtu.be/_jmH7_a3luA",__FILE__,__LINE__);
	 	}
	 }
	}
	
	
	$GLOBALS["CLASS_UNIX"]->CPU_NUMBER();
	$KERNEL_VERSION=$GLOBALS["CLASS_UNIX"]->KERNEL_VERSION();
	$ipset=$GLOBALS["CLASS_UNIX"]->find_program("ipset");
	$cgrulesengd=$GLOBALS["CLASS_UNIX"]->find_program("cgrulesengd");
	$dialog=$GLOBALS["CLASS_UNIX"]->find_program("dialog");
	$msktutil=$GLOBALS["CLASS_UNIX"]->find_program("msktutil");
	$wpa_supplicant=$GLOBALS["CLASS_UNIX"]->find_program("wpa_supplicant");
	$hostapd=$GLOBALS["CLASS_UNIX"]->find_program("hostapd");
	$losetup=$GLOBALS["CLASS_UNIX"]->find_program("losetup");
	$vconfig=$GLOBALS["CLASS_UNIX"]->find_program("vconfig");
	$iscsiadm=$GLOBALS["CLASS_UNIX"]->find_program("iscsiadm");
	$ietd=$GLOBALS["CLASS_UNIX"]->find_program("ietd");
	$cgrulesengd=$GLOBALS["CLASS_UNIX"]->find_program("cgrulesengd");
	$arpd=$GLOBALS["CLASS_UNIX"]->find_program("arpd");
	$iscsid=$GLOBALS["CLASS_UNIX"]->find_program("iscsid");
	$ftp_proxy=$GLOBALS["CLASS_UNIX"]->find_program("ftp-proxy");
	$wifidog=$GLOBALS["CLASS_UNIX"]->find_program("wifidog");
	$freshclam=$GLOBALS["CLASS_UNIX"]->find_program("freshclam");
	$memcached=$GLOBALS["CLASS_UNIX"]->find_program("memcached");
	$suricata=$GLOBALS["CLASS_UNIX"]->find_program("suricata");
	$vde_switch=$GLOBALS["CLASS_UNIX"]->find_program("vde_switch");
	$ucarp=$GLOBALS["CLASS_UNIX"]->find_program("ucarp");
	$ntpdate=$GLOBALS["CLASS_UNIX"]->find_program("ntpdate");
	$freeradius=$GLOBALS["CLASS_UNIX"]->find_program("freeradius");
	$haproxy=$GLOBALS["CLASS_UNIX"]->find_program("haproxy");
	$ebtables=$GLOBALS["CLASS_UNIX"]->find_program("ebtables");
	$squid27=$GLOBALS["CLASS_UNIX"]->find_program("squid27");
	$apache2=$GLOBALS["CLASS_UNIX"]->LOCATE_APACHE_BIN_PATH();
	$tar=$GLOBALS["CLASS_UNIX"]->find_program("tar");
	$offlineimap=$GLOBALS["CLASS_UNIX"]->find_program("offlineimap");
	$postscreen=$GLOBALS["CLASS_UNIX"]->LOCATE_POSTFIX_POSTSCREEN();
	$ipset=$GLOBALS["CLASS_UNIX"]->find_program("ipset");
	$aspell=$GLOBALS["CLASS_UNIX"]->find_program("aspell");
	$curlftpfs=$GLOBALS["CLASS_UNIX"]->find_program("curlftpfs");
	$muninnode=$GLOBALS["CLASS_UNIX"]->find_program("munin-node");
	$CURL_PATH=$GLOBALS["CLASS_UNIX"]->find_program("curl");
	$miltergreylist=$GLOBALS["CLASS_UNIX"]->find_program("milter-greylist");
	$smbd=$GLOBALS["CLASS_UNIX"]->find_program("smbd");
	$iptables=$GLOBALS["CLASS_UNIX"]->find_program("iptables");
	$php_fpm=$GLOBALS["CLASS_UNIX"]->find_program("php5-fpm");
	$ntopng=$GLOBALS["CLASS_UNIX"]->find_program("ntopng");
	$pureftpd=$GLOBALS["CLASS_UNIX"]->find_program("pure-ftpd");
	$sabnzbdplus=$GLOBALS["CLASS_UNIX"]->find_program("sabnzbdplus");
	$rpc_nfsd=$GLOBALS["CLASS_UNIX"]->find_program("rpc.nfsd");
	$dstat=$GLOBALS["CLASS_UNIX"]->find_program("dstat");
	$gnuplot=$GLOBALS["CLASS_UNIX"]->find_program("gnuplot");
	$VBoxService=$GLOBALS["CLASS_UNIX"]->find_program("VBoxService");
	$kinit=$GLOBALS["CLASS_UNIX"]->find_program("kinit");
	$iostat=$GLOBALS["CLASS_UNIX"]->find_program("iostat");
	$openvpn_bin=$GLOBALS["CLASS_UNIX"]->find_program("openvpn");
	$zip=$GLOBALS["CLASS_UNIX"]->find_program("zip");
	if(!is_file($zip)){$zip="/usr/bin/zip";}
	
	if(!is_file($php_fpm)){$php_fpm=$GLOBALS["CLASS_UNIX"]->find_program("php-fpm");}
	if($GLOBALS["VERBOSE"]){echo "PROCESS 1 --- ".__LINE__." --- \n";}
	
	var_lib_php();
	buildCronStatistics();
	if($GLOBALS["VERBOSE"]){echo "PROCESS 1 --- ".__LINE__." --- \n";}
	
	if(is_file($XVF_WORKPATH)){
		$fjih=strtoupper(trim(@file_get_contents($XVF_WORKPATH)));
		if($fjih=="TRUE"){@file_put_contents($TVF_WORKPATH,"VFJVRQ==");
		}else{
			@file_put_contents(base64_decode($TVF_WORKPATH),"RkFMU0U=");
		}
	}else{
		@file_put_contents(base64_decode($TVF_WORKPATH),"RkFMU0U=");
	}
	@chmod($TVF_WORKPATH,0755);
	
	
	if(!is_file($dialog)){
		$TimeEx=$GLOBALS["CLASS_UNIX"]->file_time_min("/etc/artica-postfix/install.dialog.time");
		if($TimeEx>15){
			$cmd=trim("{$GLOBALS["nohup"]} {$GLOBALS["NICE"]} {$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.installv2.php --dialog >/dev/null 2>&1");
			shell_exec2($cmd);
		}
	}
	if($GLOBALS["VERBOSE"]){echo "PROCESS 1 --- ".__LINE__." --- \n";}
	@file_put_contents("/etc/artica-postfix/settings/Daemons/mysqld_version",__mysqld_version());
	@file_put_contents("/etc/artica-postfix/settings/Daemons/DEBIAN_VERSION_NAME",__debian_version_name());
	@file_put_contents("/etc/artica-postfix/settings/Daemons/DEBIAN_VERSION",$GLOBALS["CLASS_UNIX"]->DEBIAN_VERSION());
	@file_put_contents("/etc/artica-postfix/settings/Daemons/VMWARE_HOST",IS_VMWARE_HOST());
	@file_put_contents("/etc/artica-postfix/settings/Daemons/VIRTUALBOX_HOST",IS_VIRTUALBOX_HOST());
	@file_put_contents("/etc/artica-postfix/settings/Daemons/XEN_HOST",$GLOBALS["CLASS_UNIX"]->IS_CITRIXXEN_HOST());
	@file_put_contents("/etc/artica-postfix/settings/Daemons/HYPERV_HOST",IS_HYPERV_HOST());
	@file_put_contents("/etc/artica-postfix/settings/Daemons/ArchStruct",__ArchStruct());
	@file_put_contents("/etc/artica-postfix/settings/Daemons/OPENSSH_VER",openssh_version());
	@file_put_contents("/etc/artica-postfix/settings/Daemons/MEM_TOTAL_INSTALLEE",$GLOBALS["CLASS_UNIX"]->MEM_TOTAL_INSTALLEE());
	@file_put_contents("/etc/artica-postfix/settings/Daemons/LinuxDistributionCodeName", $GLOBALS["CLASS_UNIX"]->LINUX_CODE_NAME());
	@file_put_contents("/etc/artica-postfix/settings/Daemons/LinuxDistributionFullName", $GLOBALS["CLASS_UNIX"]->LINUX_DISTRIBUTION());
	@file_put_contents("/etc/artica-postfix/settings/Daemons/TOTAL_MEMORY_MB", $GLOBALS["CLASS_UNIX"]->TOTAL_MEMORY_MB());
	@file_put_contents("/etc/artica-postfix/settings/Daemons/ifconfig_all_ips", serialize($GLOBALS["CLASS_UNIX"]->ifconfig_all_ips()));
	
	
	if($GLOBALS["VERBOSE"]){echo "PROCESS 1 --- ".__LINE__." --- \n";}
	@file_put_contents("/etc/artica-postfix/settings/Daemons/LOCAL_SID", $GLOBALS["CLASS_UNIX"]->GET_LOCAL_SID());
	@file_put_contents("/etc/artica-postfix/settings/Daemons/CURL_PATH", $CURL_PATH);
	@file_put_contents("/etc/artica-postfix/settings/Daemons/EXEC_NICE", $GLOBALS["CLASS_UNIX"]->EXEC_NICE());
	@file_put_contents("/etc/artica-postfix/settings/Daemons/PHP_BIN_PATH", $GLOBALS["PHP5"]);
	@file_put_contents("/etc/artica-postfix/settings/Daemons/SQUID_BIN_PATH", $GLOBALS["CLASS_UNIX"]->LOCATE_SQUID_BIN());
	if(is_file("/etc/cron.d/php5")){@unlink("/etc/cron.d/php5");shell_exec2("/etc/init.d/cron reload");}
	if(is_file("/usr/local/bin/sarg")){@unlink("/usr/local/bin/sarg");}
	
	if($GLOBALS["CLASS_UNIX"]->ISMemoryHiger1G()){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/MEM_HIGER_1G",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/MEM_HIGER_1G",0);
	}
	if($GLOBALS["VERBOSE"]){echo "PROCESS 1 --- ".__LINE__." --- \n";}
	if(is_file($apache2)){
		$MODAPACHE["mod_authnz_ldap.so"]="APACHE_MOD_AUTHNZ_LDAP";
		$MODAPACHE["mod_qos.so"]="APACHE_MOD_QOS";
		$MODAPACHE["mod_security2.so"]="APACHE_MOD_SECURITY";
		$MODAPACHE["mod_evasive20.so"]="APACHE_MOD_EVASIVE";
		$MODAPACHE["mod_cache.so"]="APACHE_MOD_CACHE";
		$MODAPACHE["mod_geoip.so"]="APACHE_MOD_GEOIP";
		$MODAPACHE["mod_pagespeed.so"]="APACHE_MOD_PAGESPEED";
		$MODAPACHE["mod_info.so"]="APACHE_MOD_INFO";
		$MODAPACHE["mod_status.so"]="APACHE_MOD_STATUS";
		$MODAPACHE["mod_suexec.so"]="APACHE_MOD_SUEXEC";
		$MODAPACHE["mod_fcgid.so"]="APACHE_MOD_FCGID";
		$MODAPACHE["mod_log_sql_mysql.so"]="APACHE_MOD_LOGSSQL";
		$MODAPACHE["mod_bw.so"]="APACHE_MOD_BW";
		$MODAPACHE["mod_python.so"]="APACHE_MOD_PYTHON";
		$MODAPACHE["mod_suphp.so"]="APACHE_MOD_SUPHP";
		
		$APACHEPROXY["mod_proxy.so"]=True;
		$APACHEPROXY["mod_proxy_http.so"]=True;
		$APACHEPROXY["mod_proxy_ftp.so"]=True;
		$APACHEPROXY["mod_proxy_connect.so"]=True;
		$APACHEPROXY["mod_headers.so"]=True;
		$APACHEPROXY["mod_deflate.so"]=True;
		$APACHEPROXY["mod_proxy_html.so"]=True;
		
		@file_put_contents("/etc/artica-postfix/settings/Daemons/APACHE_INSTALLED",1);

		if($GLOBALS["CLASS_UNIX"]->APACHE_MODULE_EXISTS("mpm_itk_module")){
			@file_put_contents("/etc/artica-postfix/settings/Daemons/mpm_itk_module",1);
		}else{
			@file_put_contents("/etc/artica-postfix/settings/Daemons/mpm_itk_module",0);
		}
		$APACHE_MODULES_PATH=$GLOBALS["CLASS_UNIX"]->APACHE_MODULES_PATH();
		if(is_file("$APACHE_MODULES_PATH/mod_dav.so")){
			@file_put_contents("/etc/artica-postfix/settings/Daemons/mod_dav",1);
		}else{
			@file_put_contents("/etc/artica-postfix/settings/Daemons/mod_dav",0);
		}
		while (list ($lib, $token) = each ($MODAPACHE) ){
			if(is_file("$APACHE_MODULES_PATH/$lib")){
				@file_put_contents("/etc/artica-postfix/settings/Daemons/$token",1);
			}else{
				@file_put_contents("/etc/artica-postfix/settings/Daemons/$token",0);
			}
		}
		$APACHE_PROXY_MODE=true;
		while (list ($lib, $none) = each ($APACHEPROXY) ){if(!is_file("$APACHE_MODULES_PATH/$lib")){$APACHE_PROXY_MODE=false;break;}}
		if($APACHE_PROXY_MODE){
			@file_put_contents("/etc/artica-postfix/settings/Daemons/APACHE_PROXY_MODE",1);
		}else{
			@file_put_contents("/etc/artica-postfix/settings/Daemons/APACHE_PROXY_MODE",0);
		}		
		
		
	}
	
	if(!is_file("/usr/sbin/ss5")){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/SS5Installed", 0);
	}else{
		if(!is_file("/var/lib/ss5/ss5/mod_socks4.so")){
			@file_put_contents("/etc/artica-postfix/settings/Daemons/SS5Installed", 0);
		}else{
			@file_put_contents("/etc/artica-postfix/settings/Daemons/SS5Installed", 1);
		}
	}
	
	
	
	if(!is_file("/usr/local/bin/dsc")){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/PDNSStatsInstalled", 0);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/DSCVersion", __DSC_VERSION());
		@file_put_contents("/etc/artica-postfix/settings/Daemons/DSC_VERSION", __DSC_VERSION());
		@file_put_contents("/etc/artica-postfix/settings/Daemons/PDNSStatsInstalled", 1);
	}
	if(is_file( "/etc/artica-postfix/KASPERSKY_WEB_APPLIANCE" )){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/KASPERSKY_WEB_APPLIANCE",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/KASPERSKY_WEB_APPLIANCE",0);
	}
	
	if(is_file("/etc/artica-postfix/WEBSECURIZE")){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/WEBSECURIZE",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/WEBSECURIZE",0);
	}
	
	
	
	if(is_file("/usr/local/sbin/ulogd")){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/APP_ULOGD_INSTALLED",1);
		@file_put_contents("/etc/artica-postfix/settings/Daemons/UlogdVersion", __ulogd_version());
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/APP_ULOGD_INSTALLED",0);
	}
	
	if(is_file("/usr/local/ArticaWebConsole/sbin/artica-webconsole")){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/APP_NGINX_CONSOLE",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/APP_NGINX_CONSOLE",0);
	}
	
	if(is_file($zip)){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/APP_ZIP_INSTALLED",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/APP_ZIP_INSTALLED",0);
	}

	
	if(is_file("/usr/local/lib/openvpn-python.so")){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/APP_OPENVPN_PYTHON",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/APP_OPENVPN_PYTHON",0);
	}
	
	if(is_file("/usr/local/bin/davserver")){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/APP_DAVSERVER",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/APP_DAVSERVER",0);
	}

	if($GLOBALS["VERBOSE"]){echo "PROCESS 1 --- ".__LINE__." --- \n";}
	if(is_file( VMWARETOOLS_BIN() )){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/VMWARE_TOOLS_INSTALLED",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/VMWARE_TOOLS_INSTALLED",0);
	}
	if(is_file( $VBoxService )){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/APP_VBOXADDINTION_INSTALLED",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/APP_VBOXADDINTION_INSTALLED",0);
	}	
	
	
	if(is_file('/usr/local/bin/wanproxy')){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/WANPROXY_INSTALLED", 1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/WANPROXY_INSTALLED", 0);
	}
	if(is_file($kinit)){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/KINIT_INSTALLED", 1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/KINIT_INSTALLED", 0);
	}
	if(is_file($iostat)){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/IOSTAT_INSTALLED", 1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/IOSTAT_INSTALLED", 0);
	}	
	
	if(is_file("/usr/local/sbin/ipaudit")){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/IPAUDIT_INSTALLED", 1);
		@file_put_contents("/etc/artica-postfix/settings/Daemons/IpAuditVersion", __ipaudit_version());
		
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/IPAUDIT_INSTALLED", 0);
	}
	
	
	if(is_file("/usr/sbin/in.tftpd")){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/TFTPD_INSTALLED", 1);
		@file_put_contents("/etc/artica-postfix/settings/Daemons/TFTPD_VERSION", __tftpd_version());
		
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/TFTPD_INSTALLED", 0);
	}
	
	
	if(is_file("/opt/ufdbcat/bin/ufdbcatdd")){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/UFDBCAT_INSTALLED", 1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/UFDBCAT_INSTALLED", 0);
	}
	if(is_file("/opt/kaspersky/UpdateUtility/UpdateUtility-Console")){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/KASPERSKY_UPDATE_UTILITY_INSTALLED", 1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/KASPERSKY_UPDATE_UTILITY_INSTALLED", 0);
	}
	if(is_file("/usr/local/ArticaStats/bin/postgres")){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/POSTGRESSQL_INSTALLED", 1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/POSTGRESSQL_INSTALLED", 0);
	}
	if(is_file($pureftpd)){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/PUREFTP_INSTALLED", 1);
		if(is_file("/etc/pure-ftpd/pureftpd.pdb")){
			@file_put_contents("/etc/artica-postfix/settings/Daemons/PUREFTP_USERS", 1);
		}else{
			@file_put_contents("/etc/artica-postfix/settings/Daemons/PUREFTP_USERS", 0);
		}
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/PUREFTP_INSTALLED", 0);
	}	
	
	if(is_file($rpc_nfsd)){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/NFS_SERVER_INTSALLED",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/NFS_SERVER_INTSALLED",0);
	}
	if(is_file($dstat)){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/DSTAT_INSTALLED",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/DSTAT_INSTALLED",0);
	}	
	if(is_file($gnuplot)){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/GNUPLOT_PNG",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/GNUPLOT_PNG",0);
	}	
	
	
	if(is_file($ntopng)){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/NtopNGInstalled", 1);
		@file_put_contents("/etc/artica-postfix/settings/Daemons/NTOPNG_VERSION",ntopng_version());
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/NtopNGInstalled", 0);
	}		
	
	if(is_file($sabnzbdplus)){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/APP_SABNZBDPLUS_INSTALLED",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/APP_SABNZBDPLUS_INSTALLED",0);
	}	
	
	if(is_file($muninnode)){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/MUNIN_CLIENT_INSTALLED",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/MUNIN_CLIENT_INSTALLED",0);
	}	
	if(is_file($php_fpm)){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/PHPFPM_INSTALLED",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/PHPFPM_INSTALLED",0);
	}
	if(is_file($offlineimap)){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/offlineimap_installed",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/offlineimap_installed",0);
	}
	if(is_file($postscreen)){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/POSTSCREEN_INSTALLED",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/POSTSCREEN_INSTALLED",0);
	}	
	if(is_file($ipset)){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/IPSET_INSTALLED",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/IPSET_INSTALLED",0);
	}	
	if(is_file($aspell)){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/ASPELL_INSTALLED",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/ASPELL_INSTALLED",0);
	}	
	if(is_file($curlftpfs)){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/CURLFTPFS_INSTALLED",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/CURLFTPFS_INSTALLED",0);
	}
	if(is_file($smbd)){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/SAMBA_INSTALLED",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/SAMBA_INSTALLED",0);
	}	
	if(is_file($iptables)){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/IPTABLES_INSTALLED",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/IPTABLES_INSTALLED",0);
	}
	if(is_file($squid27)){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/APP_SQUID27_INSTALLED",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/APP_SQUID27_INSTALLED",0);
	}	
	if(is_file($ebtables)){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/APP_EBTABLES_INSTALLED",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/APP_EBTABLES_INSTALLED",0);
	}
	if(is_file($haproxy)){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/HAPROXY_INSTALLED",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/HAPROXY_INSTALLED",0);
	}	
	if(is_file($freeradius)){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/FREERADIUS_INSTALLED",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/FREERADIUS_INSTALLED",0);
	}
	if(is_file($ntpdate)){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/NTPDATE_INSTALLED",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/NTPDATE_INSTALLED",0);
	}	
	if(is_file($ucarp)){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/UCARP_INSTALLED",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/UCARP_INSTALLED",0);
	}
	if(is_file($vde_switch)){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/VDESWITCH_INSTALLED",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/VDESWITCH_INSTALLED",0);
	}	
	if(is_file($suricata)){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/SURICATA_INSTALLED",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/SURICATA_INSTALLED",0);
	}	
	if(is_file($memcached)){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/MEMCACHED_INSTALLED",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/MEMCACHED_INSTALLED",0);
	}
	if(is_file($freshclam)){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/FRESHCLAM_INSTALLED",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/FRESHCLAM_INSTALLED",0);
	}
	if(is_file($wifidog)){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/WIFIDOG_INSTALLED",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/WIFIDOG_INSTALLED",0);
	}
	if(is_file($ftp_proxy)){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/APP_FTP_PROXY",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/APP_FTP_PROXY",0);
	}	
	if(is_file("/usr/share/filez/index.php")){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/APP_FILEZ_WEB",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/APP_FILEZ_WEB",0);
	}
	
	if(is_file("/etc/artica-postfix/OPENVPN_APPLIANCE")){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/OPENVPN_APPLIANCE",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/OPENVPN_APPLIANCE",0);
	}

	if(is_file("$openvpn_bin")){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/OPENVPN_INSTALLED",1);
	}else{
		
	}
	
	
	if(is_file("/etc/artica-postfix/WORDPRESS_APPLIANCE")){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/WORDPRESS_APPLIANCE",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/WORDPRESS_APPLIANCE",0);
	}	
	if(is_file("/usr/share/wordpress-src/wp-includes/version.php")){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/WORDPRESS_INSTALLED",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/WORDPRESS_INSTALLED",0);
	}	
	
	
	if(is_file($miltergreylist)){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/MILTERGREYLIST_INSTALLED",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/MILTERGREYLIST_INSTALLED",0);
	}
	if(is_file($iscsid)){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/ISCSID_INSTALLED",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/ISCSID_INSTALLED",0);
	}
	if(is_dir('/opt/squidsql/data/squidlogs')){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/APP_SQUIDDB_INSTALLED",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/APP_SQUIDDB_INSTALLED",0);
	}
	if(is_file($arpd)){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/ARPD_INSTALLED",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/ARPD_INSTALLED",0);
	}
	if(is_file($cgrulesengd)){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/CGROUPS_INSTALLED",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/CGROUPS_INSTALLED",0);
	}	
	if(is_file($hostapd)){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/HOSTAPD_INSTALLED",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/HOSTAPD_INSTALLED",0);
	}	
	if(is_file($hostapd)){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/HOSTAPD_INSTALLED",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/HOSTAPD_INSTALLED",0);
	}	
	
	if(is_file($losetup)){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/LOSETUP_INSTALLED",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/LOSETUP_INSTALLED",0);
	}
	if(is_file($vconfig)){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/VLAN_INSTALLED",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/VLAN_INSTALLED",0);
	}
	if(is_file($iscsiadm)){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/ISCSI_CLIENT_INSTALLED",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/ISCSI_CLIENT_INSTALLED",0);
	}		
	if(is_file($ietd)){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/ISCSI_INSTALLED",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/ISCSI_INSTALLED",0);
	}	
	
	
	if(is_file($ipset)){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/IPSetInstalled",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/IPSetInstalled",0);
	}
	
	if($GLOBALS["VERBOSE"]){echo "msktutil -> $msktutil\n";}
	if(is_file($msktutil)){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/MSKTUTIL_INSTALLED",1);
		if($GLOBALS["VERBOSE"]){echo "MSKTUTIL_VERSION -> ...\n";}
		@file_put_contents("/etc/artica-postfix/settings/Daemons/MSKTUTIL_VERSION",__MSKTUTIL_VERSION());
	}else{
		if($GLOBALS["VERBOSE"]){echo "MSKTUTIL_VERSION -> NOT INSTALLED...\n";}
		@file_put_contents("/etc/artica-postfix/settings/Daemons/MSKTUTIL_INSTALLED",0);
	}	
	
	
	if(is_file("/lib/modules/$KERNEL_VERSION/extra/xt_ndpi.ko")){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/iptablesNDPI",1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/iptablesNDPI",0);
	}
	
	if(!is_file("/etc/artica-postfix/settings/Daemons/EnableMsftncsi")){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/EnableMsftncsi",1);
		$GLOBALS["CLASS_UNIX"]->Popuplate_cron_make("artica-msftncsi","* * * *","exec.msftncsi.php");
		shell_exec2("/etc/init.d/cron reload");
	}
	
	
	
	
	if(!is_file($cgrulesengd)){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/CGROUPS_INSTALLED", 0);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/CGROUPS_INSTALLED", 1);
	}
	
	if(!is_file("/usr/lib/apache2/modules/mod_cband.so")){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/ApacheModCbandInstalled", 0);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/ApacheModCbandInstalled", 1);
	}
	
	if(is_file("/usr/local/ArticaStats/bin/postgres")){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/StatsPostGres", 1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/StatsPostGres", 0);
	}
		
	
	
	if(is_file("/etc/cron.d/access-failed-parser")){@unlink("/etc/cron.d/access-failed-parser");}
	if(is_file("/etc/cron.d/access-logs-parser")){@unlink("/etc/cron.d/access-logs-parser");}
	if(!is_file("/etc/artica-postfix/settings/Daemons/EnableWebFTPFilter")){@file_put_contents("/etc/artica-postfix/settings/Daemons/EnableWebFTPFilter", 0);}
	if(!is_file("/etc/artica-postfix/settings/Daemons/EnableDNSPerfs")){@file_put_contents("/etc/artica-postfix/settings/Daemons/EnableDNSPerfs", 1);}
	if(!is_file("/etc/artica-postfix/settings/Daemons/EnableSquidQuotasBandwidth")){@file_put_contents("/etc/artica-postfix/settings/Daemons/EnableSquidQuotasBandwidth", 0);}
	if(!is_file("/etc/artica-postfix/settings/Daemons/SquidQuotaBandwidthRefresh")){@file_put_contents("/etc/artica-postfix/settings/Daemons/SquidQuotaBandwidthRefresh", 30);}
	if(!is_file("/etc/artica-postfix/settings/Daemons/EnableMacAddressFilter")){@file_put_contents("/etc/artica-postfix/settings/Daemons/EnableMacAddressFilter", 1);}
	if(!is_file("/etc/artica-postfix/settings/Daemons/InfluxSyslogRemote")){@file_put_contents("/etc/artica-postfix/settings/Daemons/InfluxSyslogRemote", 0);}
	if(!is_file("/etc/artica-postfix/settings/Daemons/EnableSuricata")){@file_put_contents("/etc/artica-postfix/settings/Daemons/EnableSuricata", 0);}
	if(!is_file("/etc/artica-postfix/settings/Daemons/cgroupsEnabled")){@file_put_contents("/etc/artica-postfix/settings/Daemons/cgroupsEnabled", 0);}
	if(!is_file("/etc/artica-postfix/settings/Daemons/cgroupsServiceEnabled")){@file_put_contents("/etc/artica-postfix/settings/Daemons/cgroupsServiceEnabled", 0);}
	if(!is_file("/etc/artica-postfix/settings/Daemons/EnableClamavUnofficial")){@file_put_contents("/etc/artica-postfix/settings/Daemons/EnableClamavUnofficial", 0);}
	
	$EnableClamavUnofficial=intval(@file_get_contents("/etc/artica-postfix/settings/Daemons/EnableClamavUnofficial"));
	
	
	if($EnableClamavUnofficial==1){
		if(!is_file("/etc/cron.d/clamav-unofficial-sigs-cron")){
			$CRON[]="MAILTO=\"\"";
			$CRON[]="45 * * * * root /usr/share/artica-postfix/bin/clamav-unofficial-sigs.sh -c /etc/clamav-unofficial-sigs.conf >/dev/null 2>&1";
			$CRON[]="";
			file_put_contents("/etc/cron.d/clamav-unofficial-sigs-cron",@implode("\n", $CRON));
			$CRON=array();
			chmod("/etc/cron.d/clamav-unofficial-sigs-cron",0640);
			chown("/etc/cron.d/clamav-unofficial-sigs-cron","root");
			shell_exec2("/etc/init.d/cron reload");
		}
	}
	
	if($EnableClamavUnofficial==0){
		if(is_file("/etc/cron.d/clamav-unofficial-sigs-cron")){
			@unlink("/etc/cron.d/clamav-unofficial-sigs-cron");
			shell_exec2("/etc/init.d/cron reload");
		}
	}
	
	if(!is_file("/usr/local/bin/load_balance.pl")){
		$DEBIAN_VERSION=$GLOBALS["CLASS_UNIX"]->DEBIAN_VERSION();
		$tgz="/usr/share/artica-postfix/bin/install/netbalance-debian{$DEBIAN_VERSION}.tar.gz";
		if(is_file($tgz)){
			system("$tar -xhf $tgz -C /");
			squid_admin_mysql(1, "Installed Net Balance package for Debian $DEBIAN_VERSION", null,__FILE__,__LINE__);
		}
	}
	
	if(is_file("/usr/local/bin/load_balance.pl")){
		@file_put_contents("/etc/artica-postfix/settings/Daemons/NETBALANCE_INSTALLED", 1);
	}else{
		@file_put_contents("/etc/artica-postfix/settings/Daemons/NETBALANCE_INSTALLED", 0);
	}	
	
	if($GLOBALS["VERBOSE"]){echo "PROCESS 1 --- DONE --- \n";}

}

function var_lib_php(){
	$unix=new unix();
	$df=$unix->find_program("df");
	exec("$df /var/lib/php5 2>&1",$results);
	$percent=0;
	while (list ($cidr,$none) = each ($results)){
		if(preg_match("#.*?\s+([0-9]+)\s+([0-9]+)\s+([0-9]+)\s+([0-9]+)%\s+#", $none,$re)){
			$percent=$re[4];
			break;
		}
	}
	
	if($percent<92){return;}
	squid_admin_mysql(1, "/var/lib/php5 partition size execeed 92% ({$percent}%) [action=clean]", @implode("\n", $results),__FILE__,__LINE__);
	$files=$unix->DirFiles("/var/lib/php5");
	
	while (list ($filename,$none) = each ($files)){
		$fullpath="/var/lib/php5/$filename";
		$time=$unix->file_time_min($fullpath);
		if($time>15){@unlink($fullpath);continue;}
	
	}
	
}

function buildCronStatistics(){
	$ENABLED=true;
	$SquidPerformance=0;
	$SquidStatsMonthQueue=0;
	$AsStatsAppliance=0;
	
	// if > 1 then no stats $SquidPerformance
	$InfluxSyslogRemote=intval(@file_get_contents("/etc/artica-postfix/settings/Daemons/InfluxSyslogRemote"));
	$InfluxUseRemote=intval(@file_get_contents("/etc/artica-postfix/settings/Daemons/InfluxUseRemote"));
	if(is_file("/etc/artica-postfix/settings/Daemons/SquidPerformance")){$SquidPerformance=intval(@file_get_contents("/etc/artica-postfix/settings/Daemons/SquidPerformance"));}
	if($InfluxUseRemote==0){$InfluxSyslogRemote=0;}
	
	if(is_file("/etc/artica-postfix/STATS_APPLIANCE")){
		$InfluxUseRemote=0;
		$SquidPerformance=0;
		$AsStatsAppliance=1;
	}
	
	if($AsStatsAppliance==1){
		$time_file=$GLOBALS["CLASS_UNIX"]->file_time_min("/usr/share/artica-postfix/ressources/interface-cache/suricata.dashboard");
		if($time_file>15){
			$cmd=trim("{$GLOBALS["nohup"]} {$GLOBALS["NICE"]} {$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.suricata.php --dashboard >/dev/null 2>&1 &");
			shell_exec2($cmd);
		}
	}
	
	
	
	
	
	if($InfluxUseRemote==1){$ENABLED=false;}
	if($SquidPerformance>1){$ENABLED=false;}
	
	if($ENABLED){
		if(!is_file("/etc/cron.d/statistics-monthly")){
			$GLOBALS["CLASS_UNIX"]->Popuplate_cron_make("statistics-monthly","15 1 * * *","exec.squid.stats.compress.php");
			shell_exec2("/etc/init.d/cron reload");
		}
		if(!is_file("/etc/cron.d/statistics-yearly")){
			$GLOBALS["CLASS_UNIX"]->Popuplate_cron_make("statistics-yearly","30 3 1 * *","exec.squid.stats.compress.php --compress-year");
			shell_exec2("/etc/init.d/cron reload");
		}		
		
		
		buildCronStatistics_run();
		buildCronStatistics_year_run();
	}
	
	if(!$ENABLED){
		if(is_file("/etc/cron.d/statistics-monthly")){
			@unlink("/etc/cron.d/statistics-monthly");
			shell_exec2("/etc/init.d/cron reload");
		}
		if(is_file("/etc/cron.d/statistics-yearly")){
			@unlink("/etc/cron.d/statistics-yearly");
			shell_exec2("/etc/init.d/cron reload");
		}
		
	}
	
}
function buildCronStatistics_run(){
	if(!is_file("/etc/artica-postfix/settings/Daemons/SquidStatsMonthQueue")){return;}
	$SquidStatsMonthQueue=intval(@file_get_contents("/etc/artica-postfix/settings/Daemons/SquidStatsMonthQueue"));
	if($SquidStatsMonthQueue==0){return;}
	if(system_is_overloaded()){return;}
	$pidfile="/etc/artica-postfix/pids/SquidStatsMonthQueue.pid";
	$pidTime="/etc/artica-postfix/pids/SquidStatsMonthQueue.time";
	$pid=$GLOBALS["CLASS_UNIX"]->get_pid_from_file($pidfile);
	if($GLOBALS["CLASS_UNIX"]->process_exists($pid)){return;}
	$timeExec=$GLOBALS["CLASS_UNIX"]->file_time_min($pidTime);
	if($timeExec<15){return;}
	$cmd="{$GLOBALS["NICE"]}{$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.squid.stats.compress.php >/dev/null 2>&1 &";
	shell_exec2(trim($cmd));
}
function buildCronStatistics_year_run(){
	
	$cmd="{$GLOBALS["NICE"]}{$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.squid.stats.compress.php --compress-year >/dev/null 2>&1 &";
	if(!is_file("/etc/artica-postfix/settings/Daemons/SquidStatsYearQueue")){return;}
	$SquidStatsYearQueue=intval(@file_get_contents("/etc/artica-postfix/settings/Daemons/SquidStatsYearQueue"));
	if($SquidStatsYearQueue==0){return;}
	if(system_is_overloaded()){return;}
	$pidfile="/etc/artica-postfix/pids/SquidStatsYearQueue.pid";
	$pidTime="/etc/artica-postfix/pids/SquidStatsYearQueue.time";
	$pid=$GLOBALS["CLASS_UNIX"]->get_pid_from_file($pidfile);
	if($GLOBALS["CLASS_UNIX"]->process_exists($pid)){return;}
	$timeExec=$GLOBALS["CLASS_UNIX"]->file_time_min($pidTime);
	if($timeExec<15){return;}
	shell_exec2(trim($cmd));
}

function VMWARETOOLS_BIN(){
   if(is_file("/usr/bin/vmtoolsd")){return "/usr/sbin/vmtoolsd";}
   if(is_file("/usr/sbin/vmware-guestd")){return "/usr/sbin/vmware-guestd";}
   if(is_file("/usr/bin/vmware-toolbox-cmd")){return "/usr/bin/vmware-toolbox-cmd";}
   if(is_file("/usr/lib/vmware-tools/bin32/vmware-user-loader")){return "/usr/lib/vmware-tools/bin32/vmware-user-loader";}
   if(is_file("/usr/sbin/vmtoolsd")){return "/usr/sbin/vmtoolsd";} 

}

function NTOPNG_INTERFACES(){
	$CacheFile="/etc/artica-postfix/settings/Daemons/NTOPNG_INTERFACES";
	$TimeExec=$GLOBALS["CLASS_UNIX"]->file_time_min($CacheFile);
	if($TimeExec<120){return;}
	
	$masterbin=$GLOBALS["CLASS_UNIX"]->find_program("ntopng");
	exec("$masterbin -h 2>&1",$results);
	while (list ($index, $ligne) = each ($results) ){
		if(preg_match("#\s+([0-9])\.\s+(.+)#", $ligne,$re)){
			$arrayINT[trim($re[2])]=$re[1];
		}
	}
	
	@unlink($CacheFile);
	@file_put_contents($CacheFile, serialize($arrayINT));
	
}

function IS_VMWARE_HOST(){
	if(is_file("/etc/artica-postfix/VMWARE_NOHOST")){
		@unlink("/etc/artica-postfix/VMWARE_HOST");
		@unlink("/etc/artica-postfix/VMWARE_NOHOST");
	}
	
   	if(is_file("/etc/artica-postfix/VMWARE_HOST")){
   		$xtime=$GLOBALS["CLASS_UNIX"]->file_time_get("/etc/artica-postfix/VMWARE_HOST");
   		if($xtime>120){@unlink("/etc/artica-postfix/VMWARE_HOST");}
   	}
   	if(is_file("/etc/artica-postfix/VMWARE_HOST")){
   		$data=trim(@file_get_contents("/etc/artica-postfix/VMWARE_HOST"));
   		if(is_numeric($data)){return intval($data);}
   	}
   	
   	if(is_file("/etc/artica-postfix/dmidecode-type-1.cache")){
   		$xtime=$GLOBALS["CLASS_UNIX"]->file_time_get("/etc/artica-postfix/dmidecode-type-1.cache");
   		if($xtime>480){@unlink("/etc/artica-postfix/dmidecode-type-1.cache");}
   	}
   	if(is_file("/etc/artica-postfix/dmidecode-type-1.cache")){
   		$results=unserialize(@file_get_contents("/etc/artica-postfix/dmidecode-type-1.cache"));
   		
   	}else{
   		$dmidecode=$GLOBALS["CLASS_UNIX"]->find_program('dmidecode');
   		if (!is_file("$dmidecode")){return 0;}
   		exec("$dmidecode --type 1 2>&1",$results);
   		@file_put_contents("/etc/artica-postfix/dmidecode-type-1.cache", serialize($results));
   	}
   
   foreach($results as $line){
		if(preg_match("#VMware Virtual Platform#i",$line)){
			@file_put_contents("/etc/artica-postfix/VMWARE_HOST",1);
			return 1;
		}
   }
	@file_put_contents("/etc/artica-postfix/VMWARE_HOST",0);
	return 0;
}
//############################################################################## 
function IS_VIRTUALBOX_HOST(){
	if(is_file("/etc/artica-postfix/VIRTUALBOX_NOHOST")){
		@unlink("/etc/artica-postfix/VIRTUALBOX_HOST");
		@unlink("/etc/artica-postfix/VIRTUALBOX_NOHOST");
	}

	if(is_file("/etc/artica-postfix/VIRTUALBOX_HOST")){
		$xtime=$GLOBALS["CLASS_UNIX"]->file_time_get("/etc/artica-postfix/VIRTUALBOX_HOST");
		if($xtime>120){@unlink("/etc/artica-postfix/VIRTUALBOX_HOST");}
	}
	if(is_file("/etc/artica-postfix/VIRTUALBOX_HOST")){
		$data=trim(@file_get_contents("/etc/artica-postfix/VIRTUALBOX_HOST"));
		if($GLOBALS["VERBOSE"]){echo "L.".__LINE__." VIRTUALBOX_HOST='$data'\n";}
		if(is_numeric($data)){return intval($data);}
	}

	if(is_file("/etc/artica-postfix/dmidecode-type-1.cache")){
		$xtime=$GLOBALS["CLASS_UNIX"]->file_time_get("/etc/artica-postfix/dmidecode-type-1.cache");
		if($xtime>480){@unlink("/etc/artica-postfix/dmidecode-type-1.cache");}
	}
	if(is_file("/etc/artica-postfix/dmidecode-type-1.cache")){
		$results=unserialize(@file_get_contents("/etc/artica-postfix/dmidecode-type-1.cache"));
		 
	}else{
		$dmidecode=$GLOBALS["CLASS_UNIX"]->find_program('dmidecode');
		if (!is_file("$dmidecode")){return 0;}
		exec("$dmidecode --type 1 2>&1",$results);
		@file_put_contents("/etc/artica-postfix/dmidecode-type-1.cache", serialize($results));
	}
	 
	foreach($results as $line){
		if(preg_match("#VirtualBox#",$line)){
			@file_put_contents("/etc/artica-postfix/VIRTUALBOX_HOST",1);
			return 1;
		}
	}
	@file_put_contents("/etc/artica-postfix/VIRTUALBOX_HOST",0);
	return 0;
}

function IS_HYPERV_HOST(){
	if(is_file("/etc/artica-postfix/HYPERV_NOHOST")){
		@unlink("/etc/artica-postfix/HYPERV_HOST");
		@unlink("/etc/artica-postfix/HYPERV_NOHOST");
	}

	if(is_file("/etc/artica-postfix/HYPERV_HOST")){
		$xtime=$GLOBALS["CLASS_UNIX"]->file_time_get("/etc/artica-postfix/HYPERV_HOST");
		if($xtime>120){@unlink("/etc/artica-postfix/HYPERV_HOST");}
	}
	if(is_file("/etc/artica-postfix/HYPERV_HOST")){
		$data=trim(@file_get_contents("/etc/artica-postfix/HYPERV_HOST"));
		if(is_numeric($data)){return intval($data);}
	}

	if(is_file("/etc/artica-postfix/dmidecode-type-1.cache")){
		$xtime=$GLOBALS["CLASS_UNIX"]->file_time_get("/etc/artica-postfix/dmidecode-type-1.cache");
		if($xtime>480){@unlink("/etc/artica-postfix/dmidecode-type-1.cache");}
	}
	if(is_file("/etc/artica-postfix/dmidecode-type-1.cache")){
		$results=unserialize(@file_get_contents("/etc/artica-postfix/dmidecode-type-1.cache"));
			
	}else{
		$dmidecode=$GLOBALS["CLASS_UNIX"]->find_program('dmidecode');
		if (!is_file("$dmidecode")){return 0;}
		exec("$dmidecode --type 1 2>&1",$results);
		@file_put_contents("/etc/artica-postfix/dmidecode-type-1.cache", serialize($results));
	}

	foreach($results as $line){
		if(preg_match("#Microsoft Corporation#",$line)){
			@file_put_contents("/etc/artica-postfix/HYPERV_HOST",1);
			return 1;
		}
	}
	@file_put_contents("/etc/artica-postfix/HYPERV_HOST",0);
	return 0;
}
?>
